%define kpatch_dnf_ver	0.4

Name:		kpatch
Version:	0.9.10
Release:	0.2%{?dist}
Summary:	Dynamic kernel patch manager

Group:		System Environment/Kernel
License:	GPLv2
URL:		https://github.com/dynup/kpatch
Source0:	https://github.com/dynup/kpatch/archive/v%{version}.tar.gz
Source1:	kpatch-dnf-v%{kpatch_dnf_ver}.tar.gz

# RHEL-only
Patch0:		0001-contrib-disable-upstart-kpatch.conf-install.patch
Patch1:		0002-kpatch-clarify-unload-unsupport.patch
Patch2:		0003-do-not-rm-selinux-rpm-owned-directory.patch

# Upstream backports
Patch100:	0100-kpatch-build-add-missing-include-for-musl.patch
Patch101:	0101-kpatch-Add-function-to-adjust-new-sysfs-attribute-st.patch
Patch102:	0102-Fix-sympos-for-gcc-14.patch
Patch103:	0103-create-diff-object-Fix-function-pointer-rela-on-s390.patch
Patch104:	0104-kpatch-build-add-full-paths-to-build.log-for-changed.patch
Patch105:	0105-CDO-Handle-.data.once-sections.patch
Patch106:	0106-create-diff-object-handle-__initcall_stub-with-CONFI.patch
Patch107:	0107-kpatch-build-support-CONFIG_LTO_CLANG_THIN.patch
Patch108:	0108-create-diff-object-compare-section-name-with-kpatch_.patch
Patch109:	0109-kpatch-build-add-support-for-clang-pgo.patch
Patch110:	0110-create-diff-object-ignore-section-.rel.llvm.call-gra.patch
Patch111:	0111-kpatch-build-Run-objtool-on-thinlto-files.patch
Patch112:	0112-kpatch-build-skip-more-symbols-in-locals_match.patch
Patch113:	0113-kpatch-build-ignore-changes-in-.comment-section.patch
Patch114:	0114-kpatch-build-handle-init-version-timestamp.o.patch
Patch115:	0115-kpatch-build-Ignore-missing-PARA_STRUCT_SIZE-for-6.8.patch
Patch116:	0116-kpatch-build-Always-do-LLVM-1-with-CONFIG_CC_IS_CLAN.patch
Patch117:	0117-CDO-ignore-alloc_tags-section.patch
Patch118:	0118-kpatch-build-lto-sed-logic-for-lto-obj-path-in-newer.patch
Patch119:	0119-aarch64-create-diff-object-implementation.patch
Patch120:	0120-aarch64-kmod-kpatch-syscall.h-add-aarch64-helper.patch
Patch121:	0121-aarch64-kpatch-build-aarch64-implementation.patch
Patch122:	0122-aarch64-documentation-update.patch
Patch123:	0123-arm64-Skip-offset-check-in-kpatch_bundle_symbols.patch

# kpatch-dnf backports (inactive -- for future reference)
#Patch200:	0200-foo-bar-etcetera.patch

BuildRequires:	make

Requires:	bash kmod binutils
Recommends:	kpatch-dnf


%description
kpatch is a live kernel patch module manager.  It allows the user to manage
a collection of binary kernel patch modules which can be used to dynamically
patch the kernel without rebooting.

%package -n kpatch-build
Summary:	Build tool for kpatch
BuildRequires:	gcc kernel-devel elfutils elfutils-devel

%description -n kpatch-build
kpatch-build is a tool to build patches for kpatch.

%package -n kpatch-runtime
Summary:	Dynamic kernel patch manager
Requires:	bash kmod binutils
Suggests:	kpatch-dnf
Provides:	kpatch = %{version}-%{release}
Obsoletes:	kpatch < 0.9.4-1.6
BuildArch:	noarch

%description -n kpatch-runtime
kpatch is a live kernel patch module manager.  It allows the user to manage
a collection of binary kernel patch modules which can be used to dynamically
patch the kernel without rebooting.

%package -n kpatch-dnf
Summary:	kpatch-patch manager plugin for DNF
Version:	%{version}_%{kpatch_dnf_ver}
BuildRequires:	python3-devel python3-dnf
Requires:	python3-dnf python3-hawkey
Provides:	kpatch-dnf
BuildArch:	noarch

%description -n kpatch-dnf
kpatch-dnf is a DNF plugin that manages subscription to kpatch-patch updates.
When enabled, kernel packages are automatically subscribed to corresponding
kpatch-patch packages updates.

%prep
%setup -q
%patch -P 0 -p1
%patch -P 1 -p1
%patch -P 2 -p1
# Use this to apply upstream patches to kpatch
%autopatch -p1 -m 100 -M 199

%setup -D -T -a 1

# Use this to apply patches to kpatch-dnf (inactive)
#cd kpatch-dnf-%{kpatch_dnf_ver}
#patch -P 200 -p1
#cd ..

%build
make

make -C kpatch-dnf-%{kpatch_dnf_ver}

%install
make install PREFIX=/usr DESTDIR=%{buildroot}
mkdir -p %{buildroot}/%{_sharedstatedir}/kpatch

make install PREFIX=/usr DESTDIR=%{buildroot} PYTHONSITES=%{python3_sitelib} -C kpatch-dnf-%{kpatch_dnf_ver}

%files -n kpatch-build
%{_bindir}/kpatch-build
%{_libexecdir}/%{name}
%{_datadir}/%{name}
%{_mandir}/man1/kpatch-build.1*

%files -n kpatch-runtime
%{_sbindir}/kpatch
%{_usr}/lib/systemd/system/kpatch.service
%{_sharedstatedir}/kpatch
%doc %{_mandir}/man1/kpatch.1.gz

%files -n kpatch-dnf
%{python3_sitelib}/dnf-plugins/kpatch.py
%{python3_sitelib}/dnf-plugins/__pycache__
%config(noreplace) %{_sysconfdir}/dnf/plugins/kpatch.conf
%doc %{_mandir}/man8/dnf.kpatch.8.gz

%post -n kpatch-dnf
echo "To enable automatic kpatch-patch subscription, run:"
echo -e "\t$ dnf kpatch auto"

%changelog
* Wed May  7 2025 Michel Lind <salimma@centosproject.org> - 0.9.10-0.2
- Refresh clang PGO patches for kernel 6.13

* Tue Feb 11 2025 Michel Lind <salimma@centosproject.org> - 0.9.10-0.1
- Update to 0.9.10
- Enable kpatch-build on aarch64
- Rebase EL-only patches
- Refresh clang PGO patches
- Switch to autopatch for easier application of upstream patches

* Wed Jun 12 2024 Davide Cavalca <dcavalca@centosproject.org> - 0.9.8-1.4
- Merge upstream changes for c10s into Hyperscale

* Fri May 31 2024 Davide Cavalca <dcavalca@centosproject.org> - 0.9.8-1.3
- Backport two more fixes and refresh patches

* Fri May 3 2024 Joe Lawrence <joe.lawrence@redhat.com> 0.9.7-3
- Fix cs10 build error on missing `make` command
- Fix "warning: %%patchN is deprecated"

* Fri Oct 27 2023 Davide Cavalca <dcavalca@centosproject.org> - 0.9.8-1.2
- Backport three upstream fixes

* Wed Mar 15 2023 Davide Cavalca <dcavalca@centosproject.org> - 0.9.8-1.1
- Update to 0.9.8
- Refresh clang PGO patches

* Wed Dec 07 2022 Davide Cavalca <dcavalca@centosproject.org> - 0.9.7-2.1
- Merge upstream changes into Hyperscale

* Wed Nov 16 2022 Yannick Cote <ycote@redhat.com> 0.9.7-2
- augment kpatch-dnf package versioning to satisfy build (rhbz#2121212)

* Wed Nov 09 2022 Yannick Cote <ycote@redhat.com> 0.9.7-1
- rebase kpatch user utility code to v0.9.7 (rhbz#2121212)

* Tue Oct 25 2022 Davide Cavalca <dcavalca@centosproject.org> - 0.9.7-1.1
- Update to 0.9.7
- Backport patches for clang PGO

* Fri Jun 10 2022 Yannick Cote <ycote@redhat.com> 0.9.4-3
- Do not rm selinux rpm owned directory (rhbz#2053413)

* Thu Jan 27 2022 Yannick Cote <ycote@redhat.com> 0.9.4-2
- Add /usr/lib/kpatch to install and files list to appease SELinux (rhbz#2030004)

* Wed Sep 29 2021 Artem Savkov <asavkov@redhat.com> - 0.9.4-1
- Rebase to 0.9.4

* Fri Sep 03 2021 Davide Cavalca <dcavalca@centosproject.org> - 0.9.4-1.6
- Sync with c8s-sig-hyperscale
- Update to 0.9.4
- Add kpatch-build arched subpackage
- Add kpatch-runtime noarch subpackage to provide and obsolete kpatch

* Mon Aug 09 2021 Mohan Boddu <mboddu@redhat.com> - 0.9.3-3
- Rebuilt for IMA sigs, glibc 2.34, aarch64 flags
  Related: rhbz#1991688

* Thu Jun 10 2021 Joe Lawrence <joe.lawrence@redhat.com> - 0.9.3-2
- Rebase to latest upstream (via backport patch)

* Tue May 18 2021 Joel Savitz <jsavitz@redhat.com> - 0.9.3-1
- Rebase to latest upstream

* Fri Apr 16 2021 Mohan Boddu <mboddu@redhat.com> - 0.9.2-5
- Rebuilt for RHEL 9 BETA on Apr 15th 2021. Related: rhbz#1947937

* Fri Mar 05 2021 Joe Lawrence <joe.lawrence@redhat.com> 0.9.2-4
- Fix kpatch-dnf package description typos (rhbz#1934292)

* Mon Jan 04 2021 Julien Thierry <jthierry@redhat.com> 0.9.2-2
- Remove kpatch-dnf dependency on python3 (rhbz#1912457)

* Wed Dec 2 2020 Joe Lawrence <joe.lawrence@redhat.com> 0.9.2-1
- initial kpatch utility build for rhel-9.0.0 (rhbz#1901593)
